<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <!-- Popper Development version -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css" />
    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <!-- Content Header (Page header) -->
    <h1 class="text-center">Quản trị contact</h1>

    <!-- Main content -->
    <section class="content">
        <!-- Vùng header -->
        <div class="container">
            <div class="form-group mt-3" style="display: flex; justify-content: space-between;">
                <button class="btn btn-success" id="btn-add-contact">
                    <i class="fa fa-plus"></i>&nbsp; New Contact
                </button>
            </div>
        </div>
        <!-- Contact Data Table -->
        <div class="container">
            <table class="table table-bordered table-striped table-hover" id="contact-table">
                <thead>
                    <tr>
                        <th>STT</th>
                        <th>Email</th>
                        <th>Action</th>
                    </tr>
                </thead>
            </table>
        </div>
        <!-- Vùng Modal -->

        <!-- Create contact modal -->
        <div>
            <div id="create-contact-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">
                                Create new contact
                            </h5>
                            <button class="close" data-dismiss="modal">
                                &times;
                            </button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label>Email</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-create-email" placeholder="Email"
                                            class="form-control" />
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">
                                Cancel
                            </button>
                            <button class="btn btn-primary" id="btn-create-contact">
                                Create Contact
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Update contact modal -->
        <div>
            <div id="update-contact-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">
                                Update a contact
                            </h5>
                            <button class="close" data-dismiss="modal">
                                &times;
                            </button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label>Email</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-update-email" placeholder="Email"
                                            class="form-control" />
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">
                                Cancel
                            </button>
                            <button class="btn btn-primary" id="btn-update-contact">
                                Update Contact
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Delete confirm modal -->
        <div>
            <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">
                                Contact Delete Confirmation
                            </h5>
                            <button class="close" data-dismiss="modal">
                                &times;
                            </button>
                        </div>
                        <div class="modal-body">
                            <label>Bạn có chắc chắn muốn xóa contact này không?</label>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-danger" id="btn-confirm-delete-contact">
                                Confirm
                            </button>
                            <button class="btn btn-secondary" data-dismiss="modal">
                                Cancel
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        </div>
    </section>
</body>

</html>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // Biến toàn cục để lưu trữ id contact đang đc update or delete. Mặc định = 0;
    var gContactId = 0;

    const gBASE_URL = "http://localhost:8000/api/v1/contacts";

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gCONTACT_COLS = [
        "stt",
        "email",
        "action",
    ];

    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gSTT_COL = 0;
    const gEMAIL_COL = 1;
    const gACTION_COL = 2;

    // Biến toàn cục để hiển lưu STT
    var gSTT = 1;
    // Khai báo DataTable & mapping collumns
    var gContactTable = $("#contact-table").DataTable({
        searching: false,
        ordering: false,
        columns: [
            { data: gCONTACT_COLS[gSTT_COL] },
            { data: gCONTACT_COLS[gEMAIL_COL] },
            { data: gCONTACT_COLS[gACTION_COL] },
        ],
        columnDefs: [
            {
                // định nghĩa lại cột STT
                targets: gSTT_COL,
                render: function () {
                    return gSTT++;
                },
            },
            {
                // định nghĩa lại cột action
                targets: gACTION_COL,
                defaultContent: `
                    <i class="fas fa-edit edit-contact" style = "color: #00a6fb; cursor: pointer" data-toggle="tooltip" data-placement="top" title="Edit"></i>
                    <i class="fa fa-trash delete-contact" aria-hidden="true" style = "color: #d00000; cursor: pointer" data-toggle="tooltip" data-placement="top" title="Delete"></i>
                `,
            },
        ],
    });

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        // thực hiện tải trang
        onPageLoading();
        // 2 - C: gán sự kiện Create - Thêm mới contact
        $("#btn-add-contact").on("click", function () {
            onBtnAddNewContactClick();
        });
        // 3 - U: gán sự kiện Update - Sửa 1 contact
        $("#contact-table").on("click", ".edit-contact", function () {
            onBtnEditContactClick(this);
        });
        // 4 - D: gán sự kiện Delete - Xóa 1 contact
        $("#contact-table").on("click", ".delete-contact", function () {
            onBtnDeleteContactClick(this);
        });

        // gán sự kiện cho nút Create Contact (trên modal)
        $("#btn-create-contact").on("click", function () {
            onBtnCreateContactClick();
        });

        // gán sự kiện cho nút Update Contact (trên modal)
        $("#btn-update-contact").on("click", function () {
            onBtnUpdateContactClick();
        });
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi trang được load
    function onPageLoading() {
        // 1 - R: Read / Load Contact to DataTable
        getAllContacts();
    }

    // Hàm xử lý sự kiện khi nút New Contact đc click
    function onBtnAddNewContactClick() {
        // hiển thị modal lên
        $("#create-contact-modal").modal("show");
    }

    // Hàm xử lý sự kiện khi icon edit contact trên bảng đc click
    function onBtnEditContactClick(paramBtnEdit) {
        // lưu thông tin contactId đang được edit vào biến toàn cục
        gContactId = getContactIdFromButton(paramBtnEdit);
        // load dữ liệu vào các trường dữ liệu trong modal
        getContactById(gContactId);
    }

    // hàm xử lý sự kiện create contact modal click
    function onBtnCreateContactClick() {
        // khai báo đối tượng chứa contact data
        var vContactObj = {
            email: "",
        };
        // B1: Thu thập dữ liệu
        getCreateContactData(vContactObj);
        // B2: Validate insert
        var vIsContactValidate = validateContactData(vContactObj);
        if (vIsContactValidate) {
            // B3: insert contact
            $.ajax({
                type: "post",
                headers: {
                    "Content-Type": "application/json",
                },
                url: gBASE_URL,
                dataType: "json",
                data: JSON.stringify(vContactObj),
                success: function (paramData) {
                    console.log(paramData);
                    handleInsertContactSuccess();
                },
                error: function (error) {
                    console.log(error);
                },
            });
        }
    }

    // hàm xử lý sự kiện update contact modal click
    function onBtnUpdateContactClick() {
        // khai báo đối tượng chứa contact data
        var vContactObj = {
            email: ""
        };
        // B1: Thu thập dữ liệu
        getUpdateContactData(vContactObj);
        // B2: Validate update
        var vIsContactValidate = validateContactData(vContactObj);
        if (vIsContactValidate) {
            // B3: update contact
            $.ajax({
                type: "put",
                headers: {
                    "Content-Type": "application/json",
                },
                url: gBASE_URL + "/" + gContactId,
                dataType: "json",
                data: JSON.stringify(vContactObj),
                success: function (paramData) {
                    console.log(paramData);
                    // B4: xử lý front-end
                    handleUpdateContactSuccess();
                },
                error: function (error) {
                    console.log(error);
                },
            });
        }
    }

    //hàm thực thi khi nút Delete được ấn
    function onBtnDeleteContactClick(paramBtnEdit) {
        $("#delete-confirm-modal").modal("show");
        gContactId = getContactIdFromButton(paramBtnEdit);
        $(document).on("click", "#btn-confirm-delete-contact", function () {
            $.ajax({
                type: "delete",
                url: gBASE_URL + "/" + gContactId,
                dataType: "json",
                success: function (paramData) {
                    console.log(paramData);
                    alert("Xóa thành công");
                    getAllContacts();
                    $("#delete-confirm-modal").modal("hide");
                },
                error: function (error) {
                    console.log(error);
                },
            });
        });
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách contact
    function getAllContacts() {
        $.ajax({
            type: "get",
            url: gBASE_URL,
            dataType: "json",
            success: function (paramData) {
                console.log(paramData);
                loadDataToContactTable(paramData.data);
            },
            error: function (error) {
                console.log(error);
            },
        });
    }
    /** load contact array to DataTable
     * in: Contact array
     * out: Contact table has data
     */
    function loadDataToContactTable(paramContactArr) {
        gSTT = 1;
        gContactTable.clear();
        gContactTable.rows.add(paramContactArr);
        gContactTable.draw();
    }

    // hàm get contact by id
    function getContactById(paramContactId) {
        $.ajax({
            type: "get",
            url: gBASE_URL + "/" + paramContactId,
            dataType: "json",
            success: function (paramData) {
                console.log(paramData);
                showContactDataToModal(paramData.data);
            },
            error: function (error) {
                console.log(error);
            },
        });
        // hiển thị modal lên
        $("#update-contact-modal").modal("show");
    }

    // hàm show contact obj lên modal
    function showContactDataToModal(paramContact) {
        $("#input-update-email").val(paramContact.email);
    }

    // hàm thu thập dữ liệu để create contact
    function getCreateContactData(paramContactObj) {
        paramContactObj.email = $("#input-create-email").val().trim();
    }

    // hàm thu thập dữ liệu để update contact
    function getUpdateContactData(paramContactObj) {
        paramContactObj.email = $("#input-update-email").val().trim();
    }

    // hàm validate data
    function validateContactData(paramContactObj) {
        if (paramContactObj.email == "") {
            alert("Email cần nhập");
            return false;
        }
        if (validateEmail(paramContactObj.email) == false) {
            alert("Email nhập vào không đúng định dạng!");
            return false;
        }

        return true;
    }

    // hàm xử lý hiển thị front-end khi thêm contact thành công
    function handleInsertContactSuccess() {
        alert("Thêm contact thành công!");
        getAllContacts();
        resertCreateContactForm();
        $("#create-contact-modal").modal("hide");
    }

    // hàm xử lý hiển thị front-end khi sửa contact thành công
    function handleUpdateContactSuccess() {
        alert("Sửa contact thành công!");
        getAllContacts();
        resertUpdateContactForm();
        $("#update-contact-modal").modal("hide");
    }

    // hàm xóa trắng form create contact
    function resertCreateContactForm() {
        $("#input-create-email").val("");
    }

    // hàm xóa trắng form update contact
    function resertUpdateContactForm() {
        $("#input-update-email").val("");
    }

    // hàm dựa vào button detail (edit or delete) xác định đc id contact
    function getContactIdFromButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vContactRowData = gContactTable.row(vTableRow).data();
        return vContactRowData._id;
    }

    // hàm kiểm tra email đúng định dạng ko?
    function validateEmail(paramEmail) {
        var vValidRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        if (paramEmail.match(vValidRegex)) {
            return true;
        } else {
            return false;
        }
    }
</script>